<template>
  <v-container>
    <loading :active.sync="isLoading"
        :is-full-page="true"></loading>
    <v-form
      ref="form"
      v-model="valid"
      lazy-validation>
      <v-text-field
        v-model="values.name"
        :rules="nameRules"
        label="Name"
        required
      ></v-text-field>
      <v-text-field
        v-model="values.calories"
        :rules="caloriesRules"
        label="Calories"
        type="number"
        required
      ></v-text-field>
      <v-text-field
        v-model="values.portions"
        :rules="portionsRules"
        label="Portions"
        type="number"
        required
      ></v-text-field>
      <p class="headline font-weight-bold mt-3">
        Ingredients
      </p>
      <template v-for="(ingredient, index) in values.ingredients">
        <v-layout :key="'ingredient_'+index">
          <v-flex md1>
            <v-text-field class="ml-1"
              v-model="ingredient.quantity"
              :rules="quantityRules"
              label="Quantity"
              required
            ></v-text-field>
          </v-flex>
          <v-flex md2>
            <v-select class="mx-1"
              v-model="ingredient.measurement"
              :items="measurements"
              label="Measurement"
            ></v-select>
          </v-flex>
          <v-flex md8>
            <v-text-field class="mr-1"
              v-model="ingredient.name"
              :rules="nameRules"
              label="Name"
              required
            ></v-text-field>
          </v-flex>
          <v-flex md1>
            <v-layout align-center justify-center row fill-height>
              <v-icon v-if="index > 0"
                class="remove-button" @click="removeIngredient(index)">
                fas fa-trash-alt
              </v-icon>
            </v-layout>
          </v-flex>
        </v-layout>
      </template>
      <v-layout justify-center row>
        <v-flex xs12>
          <v-btn dark fab color="pink" @click="addIngredient()">
            <v-icon>add</v-icon>
          </v-btn>
        </v-flex>
      </v-layout>
      <p class="headline font-weight-bold mt-3">
        Directions
      </p>
      <v-textarea solo
          name="input-7-1"
          v-model="values.directions"
          :rules="directionsRules"
          required
        ></v-textarea>
      <v-btn
        :disabled="!valid"
        color="success"
        @click="save"
      >
        Add recipe
      </v-btn>
    </v-form>
  </v-container>
</template>

<style lang="scss" scoped>
.remove-button {
  cursor: pointer
}
</style>

<script>
import Loading from 'vue-loading-overlay'
import 'vue-loading-overlay/dist/vue-loading.css'

export default {
  data: () => ({
    values: {
      name: '',
      calories: null,
      portions: null,
      ingredients: [{
        name: null,
        quantity: null,
        measurement: null
      }],
      directions: null
    },
    isLoading: false,
    nameRules: [
      v => !!v || 'Name is required'
    ],
    caloriesRules: [
      v => !!v || 'Calories is required'
    ],
    portionsRules: [
      v => !!v || 'Portions is required'
    ],
    quantityRules: [
      v => !!v || 'Quantity is required'
    ],
    directionsRules: [
      v => !!v || 'Directions are required'
    ],
    measurements: [
      '', 'g', 'kg', 'mL', 'L', 'tbsp', 'tspn', 'cup'
    ],
    valid: true
  }),

  components: {
    Loading
  },
  methods: {
    save () {
      if (this.$refs.form.validate()) {
        this.isLoading = true
        this.axios
          .post('/api/recipes', this.values)
          .then(response => {
            this.isLoading = false
            let location = response.headers.location
            let url = location.split('/api')[1]

            this.$router.push(url)
          })
          .catch(error => {
            this.isLoading = false
            console.error(error)
          })
      }
    },
    addIngredient () {
      this.values.ingredients.push({
        name: null,
        quantity: null,
        measurement: null
      })
    },
    removeIngredient (index) {
      this.values.ingredients.splice(index, 1)
    }
  }
}
</script>
